<template>
    <div class="cont">
        <v-card color="primary" width="30%" class="mx-auto a white--text pa-6">
            <v-form>
                <div class="headline pt-7">欢迎来到cocode！</div>
                <div class="caption">现在登录，打开你的全新世界</div>
                <v-text-field
                    label="用户名"
                    color="secondary"
                    outlined
                    dense
                    class="mt-10"
                    :error="registerAlert"
                    :error-messages="errorMessage"
                    v-model="userName"
                    clearable
                    dark
                ></v-text-field>
                <v-text-field
                    label="密码"
                    type="password"
                    color="secondary"
                    outlined
                    dense
                    @keyup.enter="try_login"
                    :error="registerAlert"
                    v-model="password"
                    clearable
                    dark
                ></v-text-field>
                <v-img src="../../../public/timg.jpg"></v-img>
                <div class="rightwrap">
                    <v-btn color="secondary" class="mr-4 mt-3" outlined @click="to_register"
                        >注册</v-btn
                    >
                    <v-btn color="accent" class="mt-3" @click="try_login">登陆</v-btn>
                </div>
            </v-form>
        </v-card>
    </div>
</template>

<script>
import hash from "../../../node_modules/sha.js";
export default {
    name: "LoginPage",
    components: {},
    computed: {
        passwordHash() {
            return hash("sha256")
                .update(this.password)
                .digest("hex");
        },
    },
    methods: {
        try_login() {
            if (!this.userName.length || !this.password.length) {
                this.login_alert("用户名及密码不得为空！");
                return;
            }

            this.$axios({
                method: "post",
                url: `/login`,
                data: {
                    userName: this.userName,
                    password: this.passwordHash,
                },
            })
                .then(res => {
                    if (res.status === 200) {
                        const data = res.data;
                        if (data.status === "GET_SUCCESS") {
                            console.log("---save seesion----", data.user);

                            //将用户名和token放入sessionStorage
                            sessionStorage.setItem("userName", data.user.userName);
                            sessionStorage.setItem("userToken", data.user.token);
                            sessionStorage.setItem("userAvatar", data.user.avatar);
                            sessionStorage.setItem("userColor", data.user.color);
                            sessionStorage.setItem("nickName", data.user.nickName);

                            //将用户信息放入vuex
                            this.$store.dispatch("setUser", data.user);

                            //打印login状态
                            // console.log(this.$store.state.isLogin);
                            // console.log(this.$store.state.userAvatar);

                            this.$router.push("/write");
                            return;
                        }

                        if (data.status === "NAME_PASSWORD_WRONG") {
                            this.login_alert("用户名或密码错误！");
                        } else {
                            this.login_alert("出错了！");
                        }
                        this.$store.dispatch("setUser", null);
                    }
                })
                .catch(function(err) {
                    console.log(err);
                    this.login_alert("连接失败。\n请检查您的网络状态。");
                    this.$store.dispatch("setUser", null);
                });
        },
        to_register() {
            this.$router.push({ path: "/register" });
            //this.$router.push("register");
        },
        login_alert(message) {
            this.errorMessage = "" + message;
        },
    },
    beforeRouteEnter: (to, from, next) => {
        //组件内守卫
        //已登录状态回到登录界面，即 登出
        next(vm => {
            vm.$store.dispatch("setUser", null);
        });
    },
    data: () => ({
        userName: "",
        password: "",
        registerAlert: false,
        errorMessage: "",
    }),
};
</script>

<style scoped>
.cont {
    background-color: #f4ff91;
    background-image: url(../../../public/logo_bgr.png);
    background-repeat: space;
    height: 100%;
    width: 100%;
}
.a {
    top: 5%;
    position: relative;
}
.rightwrap {
    display: flex;
    justify-content: flex-end;
}
</style>
